Scopul codului

Acest cod implementează un sistem simplu de deschidere și închidere a unui locker utilizând un ecran LCD, un modul Bluetooth și o placă Arduino. Utilizatorul poate trimite o parolă prin intermediul conexiunii Bluetooth, iar dacă parola este corectă, locker-ul se va deschide pentru o perioadă de timp și apoi se va închide automat.

Componente necesare

Pentru a rula acest cod, veți avea nevoie de următoarele componente:

O placă Arduino (de exemplu, Arduino Uno)
Un modul Bluetooth (de exemplu, HC-05)
Un ecran LCD (de exemplu, LCD 16x2)
Un LED
Un buzzer
Un releu de blocare electronică
Biblioteci utilizate

Codul utilizează două biblioteci:

LiquidCrystal.h: Această bibliotecă permite controlul ecranului LCD.
SoftwareSerial.h: Această bibliotecă permite comunicarea prin intermediul modulului Bluetooth.
Pinii și conexiunile

Codul definește următoarele conexiuni între componentele hardware și pinii Arduino:

Pinul 2 al Arduino este conectat la pinul RS (Register Select) al ecranului LCD.
Pinul 3 al Arduino este conectat la pinul E (Enable) al ecranului LCD.
Pinul 4 al Arduino este conectat la pinul DB4 al ecranului LCD.
Pinul 5 al Arduino este conectat la pinul DB5 al ecranului LCD.
Pinul 6 al Arduino este conectat la pinul DB6 al ecranului LCD.
Pinul 7 al Arduino este conectat la pinul DB7 al ecranului LCD.
Pinul 8 al Arduino este conectat la pinul buzzer-ului.
Pinul 10 al Arduino este conectat la pinul RX (Receiver) al modulului Bluetooth.
Pinul 11 al Arduino este conectat la pinul TX (Transmitter) al modulului Bluetooth.
Pinul 13 al Arduino este conectat la pinul LED.
Pinul A5 al Arduino este conectat la pinul releului de blocare electronică.
Inițializare și configurare

În funcția setup(), se realizează următoarele operațiuni:

Se setează pinul LED ca ieșire utilizând pinMode(ledPin, OUTPUT).
Se inițializează ecranul LCD utilizând lcd.begin(16, 2), specificând numărul de coloane (16) și numărul de rânduri (2).
Se setează pinul releului ca ieșire și se inițializează starea de blocare electronică la LOW utilizând pinMode(lockPin, OUTPUT) și digitalWrite(lockPin, LOW).
Se setează pinul buzzer-ului ca ieșire utilizând pinMode(buzzerPin, OUTPUT).
Se inițializează comunicarea serială utilizată pentru depanare prin USB la o rată de 9600 de biți pe secundă utilizând Serial.begin(9600).
Se inițializează comunicarea serială cu modulul Bluetooth la o rată de 9600 de biți pe secundă utilizând BTSerial.begin(9600).
Se așteaptă 3 secunde pentru a permite modulului Bluetooth să se inițializeze utilizând delay(3000).
Loop principal

Funcția loop() rulează într-o buclă continuă și verifică starea de conectare Bluetooth și parolele primite. Există două scenarii majore în cadrul buclei:

Verificarea timpului de inactivitate:
Se verifică dacă a trecut un anumit interval de timp (2 minute în acest caz) de la ultima activitate.
Dacă timpul de inactivitate a expirat, se afișează un mesaj pe ecranul LCD și se activează buzzer-ul pentru a avertiza utilizatorul.
După un anumit interval de timp, se șterge mesajul de pe ecranul LCD și se dezactivează buzzer-ul.
Această verificare se face pentru a proteja sistemul în cazul în care utilizatorul nu trimite nicio parolă pentru o perioadă lungă de timp.
Verificarea parolelor primite prin Bluetooth:
Se verifică dacă există date disponibile prin intermediul modulului Bluetooth utilizând BTSerial.available().
Dacă există date disponibile, se citește parola trimisă și se stochează în variabila password.
Dacă parola este corectă (în acest exemplu, parola corectă este "1777"), se afișează un mesaj de deschidere a locker-ului pe ecranul LCD și se activează releul de blocare electronică pentru o perioadă de timp.
După o perioadă de timp, locker-ul se închide automat, se afișează un mesaj de închidere pe ecranul LCD și se dezactivează releul de blocare electronică.
Dacă parola este incorectă, se afișează un mesaj de eroare pe ecranul LCD și se activează buzzer-ul pentru a avertiza utilizatorul.